<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5">
        <h1> Create Order </h1>
      </div>
      <div class="form-group row">
        <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
        <div class="col-sm-4">
          <select id="select-size" class="form-control">
            <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
            <option value="S"> Nhỏ</option>
            <option value="M"> Vừa</option>
            <option value="L"> Lớn</option>
          </select>
        </div>
        <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-drink">
            <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Mã voucher</label>
        <div class="col-sm-4">
          <input id="input-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
        </div>
        <label class="col-sm-2 col-form-label">Loại pizza</label>
        <div class="col-sm-4">
          <select id="select-pizza" class="form-control"> <!-- select chưa có id, các option chưa có value-->
            <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
            <option value="Seafood"> Hải sản</option>
            <option value="Hawaii"> Ha wai </option>
            <option value="Bacon"> Thịt hun khói </option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-4">
          <input id="input-fullname" type="text" class="form-control" placeholder="Họ và tên">
        </div>
        <label for="" class="col-sm-2 col-form-label">Email</label>
        <div class="col-sm-4">
          <input id="input-email" type="email" class="form-control" placeholder="Email">
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Số điện thoại</label>
        <div class="col-sm-4">
          <input id="input-mobile" type="text" class="form-control" placeholder="Số điện thoại">
        </div>
        <label class="col-sm-2 col-form-label">Địa chỉ</label>
        <div class="col-sm-4">
          <input id="input-address" type="text" class="form-control" placeholder="Địa chỉ">
        </div>
      </div>
      <div class="form-group">
        <label>Lời nhắn</label>
        <textarea id="input-message" class="form-control h-75" placeholder="Lời nhắn"></textarea>
      </div>
      <div class="form-group">
        <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
        <button class="btn btn-secondary" id="btn-order-data" onclick="onBtnShowOrderClick">Show Order Data in New Form</button>
      </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function onBtnCreateOrderClick() {
      "use strict";
      console.log("Nút Create Order được ấn")

      var vOrderObj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
      }
      readDataInput(vOrderObj);

      var isCheck = validateData(vOrderObj);
      if (isCheck) {
        var vXhttp = new XMLHttpRequest();
        callAPIGetDataOrder(vXhttp, vOrderObj);

        vXhttp.onreadystatechange =
          function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              handlerCreateData(vXhttp);
            }
          }
      }
    }

    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
  











    function readDataInput(paramOrderObject) {
      "use strict";
      var vSelectComboSizeElement = document.getElementById("select-size");
      var vSelectDrinkElement = document.getElementById("select-drink");
      var vVoucherElement = document.getElementById("input-voucher");
      var vSelectPizzaElement = document.getElementById("select-pizza");
      var vFullNameElement = document.getElementById("input-fullname");
      var vEmailElement = document.getElementById("input-email");
      var vMobileElement = document.getElementById("input-mobile");
      var vAddressElement = document.getElementById("input-address");
      var vMessageElement = document.getElementById("input-message");

      paramOrderObject.kichCo = vSelectComboSizeElement.value;
      paramOrderObject.idLoaiNuocUong = vSelectDrinkElement.value;
      paramOrderObject.soLuongNuoc = vSelectDrinkElement.value;
      paramOrderObject.idVoucher = vVoucherElement.value.trim();

      paramOrderObject.loaiPizza = vSelectPizzaElement.value;
      paramOrderObject.hoTen = vFullNameElement.value.trim();
      paramOrderObject.email = vEmailElement.value.trim();
      paramOrderObject.soDienThoai = vMobileElement.value.trim();
      paramOrderObject.diaChi = vAddressElement.value.trim();
      paramOrderObject.loiNhan = vMessageElement.value.trim();

      if (paramOrderObject.kichCo == "S") {
        paramOrderObject.duongKinh = 20;
        paramOrderObject.suon = 2;
        paramOrderObject.salad = 200;
        paramOrderObject.soLuongNuoc = 2;
        paramOrderObject.thanhTien = 150000;
      }

      if (paramOrderObject.kichCo == "M") {
        paramOrderObject.duongKinh = 24;
        paramOrderObject.suon = 4;
        paramOrderObject.salad = 300;
        paramOrderObject.soLuongNuoc = 3;
        paramOrderObject.thanhTien = 200000;
      }

      if (paramOrderObject.kichCo == "L") {
        paramOrderObject.duongKinh = 30;
        paramOrderObject.suon = 8;
        paramOrderObject.salad = 500;
        paramOrderObject.soLuongNuoc = 4;
        paramOrderObject.thanhTien = 250000;
      }
    }

    function validateData(paramOrderObject) {
      "use strict";

      if (paramOrderObject.kichCo == "NOT_SELECT_COMBO") {
        alert("Bạn cần chọn combo");
        return false;
      }

      if (paramOrderObject.idLoaiNuocUong == "NOT_SELECT_DRINK") {
        alert("Bạn cần chọn đồ uống");
        return false;
      }
      if (paramOrderObject.idVoucher == "") {
        alert("Bạn cần điền mã Voucher");
        return false;
      }
      if (paramOrderObject.loaiPizza == "NOT_SELECT_PIZZA") {
        alert("Bạn cần chọn một loại pizza");
        return false;
      }
      if (paramOrderObject.hoTen == "") {
        alert("Bạn cần nhập họ và tên");
        return false;
      }
      if (paramOrderObject.email == "") {
        alert("Bạn cần nhập email");
        return false;
      }
      if (paramOrderObject.soDienThoai == "") {
        alert("Bạn cần nhập số điện thoại");
        return false;
      }
      if (paramOrderObject.diaChi == "") {
        alert("Bạn cần nhập địa chỉ");
        return false;
      }
      if (paramOrderObject.loiNhan == "") {
        alert("Bạn cần nhập lời nhắn");
        return false;
      }
      return true;
    }

    function callAPIGetDataOrder(paramXhttp, paramObjRequest) {
      "use strict";
      paramXhttp.open("POST", gBASE_URL, true);
      paramXhttp.setRequestHeader("Content-Type", "applycation/json; charset=UTF-8");
      paramXhttp.send(JSON.stringify(paramObjRequest));
      console.log(paramObjRequest);
    }

    function handlerCreateData(paramXhttp) {
      "use strict";
      var vCreateOrder = paramXhttp.responseText;
      console.log(vCreateOrder);

      var vOrderObj = JSON.parse(paramXhttp.responseText);
      var vOrderCode= vOrderObject.orderCode;

      var vElementButtonShowOrder = document.getElementById("btn-order-data");
      vElementButtonShowOrder.setAttribute("data-ordercode", vOrderCode);
    }

    function onBtnShowOrderClick(){
      var vElementButtonShowOrder = document.getElementById("btn-order-data");
      var vGetOrderCode = vElementButtonShowOrder.dataset.ordercode;
      console.log("OrderCode là: ", vGetOrderCode);
    }
  </script>


</body>

</html>